/* CHK=0xB65B */
/*+-------------------------------------------------------------------------
	ecuscrdump.c
	wht%n4hgf@gatech.edu

  Defined functions:
	screen_dump()

--------------------------------------------------------------------------*/
/*+:EDITS:*/
/*:05-07-1990-21:23-wht@n4hgf---- 2.80 --- */
/*:03-25-1990-14:11-wht@n4hgf------ x2.70 ------- */
/*:11-23-1989-03:11-wht-conditional compile for M_XENIX or M_UNIX */
/*:11-23-1989-02:57-wht-setvbuf has right order under UNIX */
/*:07-03-1989-22:57-wht------ x2.00 ----- */
/*:06-24-1989-16:53-wht-flush edits --- ecu 1.95 */

#include "ecu.h"
#include "pc_scr.h"

extern char curr_dir[];		/* current working directory */
extern int rcvr_pid;
extern int tcap_LINES;
extern int tcap_COLS;

char screen_dump_file_name[256];

/*+-------------------------------------------------------------------------
	screen_dump(scrfile) - dump physical display contents

if scrfile == NULL, default to ~/.ecu/screen.dump
--------------------------------------------------------------------------*/
void
screen_dump(scrfile)
char *scrfile;
{
uchar s133[133];
uchar schar;
register uchar *cptr = s133;
FILE *fp;
struct termio dump_tty_termio_at_entry;
struct termio dump_tty_termio_current;
int rcvr_alive = (rcvr_pid > 0);
extern struct termio tty_termio_at_entry;
int lines_left = tcap_LINES;
char *vbuf = (char *)0;

	if(rcvr_alive)
		kill_rcvr_process(SIGUSR1);

/* save keyboard termio at entry */
	ioctl(TTYIN,TCGETA,(char *)&dump_tty_termio_at_entry);

/* set keyboard to termio status at staart of execution of program 
   plus a few mods */

	dump_tty_termio_current = tty_termio_at_entry;
	dump_tty_termio_current.c_cflag &= ~(PARENB | PARODD);
	dump_tty_termio_current.c_cflag |= CS8;
	dump_tty_termio_current.c_iflag &= ~(ISTRIP);
	dump_tty_termio_current.c_lflag &= ~(ICANON | ISIG | ECHO);
	ioctl(TTYIN,TCSETAW,(char *) &dump_tty_termio_current);
	ttyflush(2);

	if(scrfile)
		fp = fopen(scrfile,"a");
	else
	{
		get_home_dir(s133);
		strcat(s133,"/.ecu/screen.dump");
		fp = fopen(s133,"a");
	}
	if(!fp)
	{
#if defined(MORSE)
		xbell(XBELL_3T,1);
#else
		ring_bell();
		nap((long)20);
		ring_bell();
#endif
		return;
	}

	if(vbuf = (char *)malloc(5120))	/* big buffer; size used elsewhere too */
#if defined(M_XENIX)	/* bassackwards */
		setvbuf(fp,_IOFBF,vbuf,5120);
#else
		setvbuf(fp,vbuf,_IOFBF,5120);
#endif

	get_tod(2,s133);
	fprintf(fp,"====> %s (phone %s) %s\n",
		shm->Ldescr,(shm->Ltelno[0]) ? shm->Ltelno : "NONE",s133);

	write(1,"\033[2i",4);	/* spill your guts, screen */

	while(1)
	{
		if(!rdchk(0))
		{
			nap(20L);
			if(!rdchk(0))
				break;
		}

		read(0,&schar,1);

		if(!lines_left)
			continue;

		if((schar > 0x7E) || (schar < 0x20))
		{
			switch(schar)
			{
			case 0x0A:
				while((cptr > s133) && (*(cptr - 1) == ' '))
					cptr--;
				*cptr++ = 0x0A;
				*cptr = 0;
				fputs(s133,fp);
				cptr = s133;
				*cptr = 0;
				--lines_left;
				continue;
			case sTL:		
			case sTR:
				schar = '.';
				break;
			case sBL:		
				schar = '`';
				break;
			case sBR:		
				schar = '\'';
				break;
			case sLT:			/* left hand T */
			case sRT:			/* right hand T */
				schar = '+';
				break;
			case sVR:			/* vertical rule */
				schar = '|';
				break;
			case sHR:			/* horizontal rule */
				schar = '-';
				break;
			default:
				schar = ' ';
			}
		}
		*cptr++ = schar;
	}

/* restore keyboard termio at entry */
	ioctl(TTYIN,TCSETAW,(char *)&dump_tty_termio_at_entry);
	ttyflush(2);

	fclose(fp);

	if(vbuf)
		free(vbuf);

/* bug in 2.3.1 sco video driver leaves "ESC[2"; use "l" (unlock tty) a noop */
	fputs("l",stdout);
/* remove the above line if you have 2.3.2 or beyond */

#if defined(MORSE)
	xbell(XBELL_DONE,1);
#else
	ring_bell();
#endif

	if(rcvr_alive)
		start_rcvr_process(0);

}	/* end of screen_dump */
