/* CHK=0x9D5E */
/*+-------------------------------------------------------------------------
	ecusetup.c -- ecu visual "argv"
	wht%n4hgf@gatech.edu

  0000000000111111111122222222223333333333444444444455555555556666
  0123456789012345678901234567890123456789012345678901234567890123
00.--[ ecu rev ]-------------------------------------------------.
01|                                                              |
02|  Name/phone number to call: ...................              |
03|  ...................        ................................ |
04|                                                              |
05|  tty: /dev/tty.....   (opened)                               | 
06|                                                              |
07|  duplex: .  baud: .....  parity: . (data bits .)             |
08|  Add NL to transmitted CR: .                                 |
09|  Add NL to received CR:    .                                 |
10|                                                              |
11|                                                              |
12|   TAB:next ^B:prev END:proceed ^D:phone dir  ESC:quit ecu    |
13`--------------------------------------------------------------'

  Defined functions:
	setup_display_baud()
	setup_display_name()
	setup_display_screen(write_lits)
	setup_display_single_char()
	setup_display_tty()
	setup_line_open()
	setup_open_status()
	setup_screen(argv_logical)
	setw_bot_msg(msg)
	setw_get_single(nondelim_list)

--------------------------------------------------------------------------*/
/*+:EDITS:*/
/*:05-07-1990-21:23-wht@n4hgf---- 2.80 --- */
/*:04-27-1990-06:15-wht@n4hgf-baud entry was in error */
/*:04-19-1990-03:07-wht@n4hgf-GCC run found unused vars -- rm them */
/*:03-25-1990-14:11-wht@n4hgf------ x2.70 ------- */
/*:11-24-1989-14:41-wht-UNIX tcap-curses blinks with high bits set on addch */
/*:07-03-1989-22:57-wht------ x2.00 ----- */
/*:06-24-1989-16:53-wht-flush edits --- ecu 1.95 */

#include <curses.h>

#define STDIO_H_INCLUDED
#define OMIT_TERMIO_REFERENCES
#include "ecu.h"
#include "ecukey.h"
#include "ecuxkey.h"
#include "pc_scr.h"

#define END		XFend

#define SETW_LINES	14
#define SETW_COLS	64
#define SETW_TLY	1
#define SETW_TLX	((80 - SETW_COLS) / 2)

#define NAME_Y		2
#define NAME_X		30
#define NAME_LEN	19
#define NAME_LX		3

#define TELNO_Y		3
#define TELNO_X		3
#define TELNO_LEN	19

#define DESCR_Y		3
#define DESCR_X		30
#define DESCR_LEN	32

#define TTY_Y		5
#define TTY_X		16
#define TTY_LEN		5
#define TTY_LX		3

#define TTYOPN_LY	5
#define TTYOPN_LX	24

#define DPX_Y		7
#define DPX_X		11
#define DPX_LX		3

#define BAUD_Y		7
#define BAUD_X		20
#define BAUD_LEN	5
#define BAUD_LX		14

#define PAR_Y		7
#define PAR_X		34
#define PAR_LX		27

#define DB_Y		7
#define DB_X		48
#define DB_LX		37
#define DB_LX2		49

#define XADDNL_Y	8
#define XADDNL_X	29
#define XADDNL_LX	3

#define RADDNL_Y	9
#define RADDNL_X	29
#define RADDNL_LX	3

extern char *numeric_revision;	/* ecunumrev.c */
extern char *revision_modifier; /* ecunumrev.c */
extern int rcvr_pid;
extern char errmsg[];

WINDOW *setw;

#define SETW_MSG_LEFTX 2
#define SETW_MSG_MAXLEN	(SETW_COLS - SETW_MSG_LEFTX - 8)
#define SETW_MSG_BOT_Y  (SETW_LINES - 1)
#define SETW_MSG_ERR_Y  (SETW_LINES - 3)

/*+-------------------------------------------------------------------------
	setw_msg(msg,y,fillch)
--------------------------------------------------------------------------*/
void
setw_msg(msg,y,fillch,last_msglen)
char *msg;
int y;
char fillch;
int *last_msglen;
{
register itmp;
register itmp2;
char msg2[80];

	if(!*last_msglen && !strlen(msg))
		return;

	wmove(setw,y,SETW_MSG_LEFTX);

	if((itmp = strlen(msg)) == 0)
	{
		itmp2 = *last_msglen + 2;
		for(itmp = 0; itmp < itmp2; itmp++)
			waddch(setw,fillch & 0xFF);
		*last_msglen = 0;
	}
	else
	{
		waddch(setw,' ');
		if(itmp > SETW_MSG_MAXLEN)
		{
			strncpy(msg2,msg,SETW_MSG_MAXLEN);
			msg2[SETW_MSG_MAXLEN + 1] = 0;
			waddstr(setw,msg2);
			itmp = strlen(msg2);
		}
		else
		{
			waddstr(setw,msg);
			itmp = strlen(msg);
		}
		waddch(setw,' ');
		if((itmp2 = *last_msglen - itmp) > 0)
		{
			while(itmp2--)
				waddch(setw,fillch & 0xFF);
		}
		*last_msglen = itmp;		/* remember last message length */
	}
	wrefresh(setw);
}	/* end of setw_msg */

/*+-------------------------------------------------------------------------
	setw_bot_msg(msg)
--------------------------------------------------------------------------*/
void
setw_bot_msg(msg)
char *msg;
{
static int last_msglen = 0;

	setw_msg(msg,SETW_MSG_BOT_Y,sHR,&last_msglen);
}	/* end of setw_bot_msg */

/*+-------------------------------------------------------------------------
	setw_err_msg(msg)
--------------------------------------------------------------------------*/
void
setw_err_msg(msg)
char *msg;
{
static int last_msglen = 0;

	setw_msg(msg,SETW_MSG_ERR_Y,' ',&last_msglen);
}	/* end of setw_err_msg */

/*+-------------------------------------------------------------------------
	setup_display_name()
--------------------------------------------------------------------------*/
void
setup_display_name()
{
	clear_area(setw,NAME_Y,NAME_X,NAME_LEN);
	waddstr(setw,shm->Llogical);

	clear_area(setw,TELNO_Y,TELNO_X,TELNO_LEN);
	clear_area(setw,DESCR_Y,DESCR_X,DESCR_LEN);
	if(strcmp(shm->Llogical,shm->Ldescr))
	{
		waddstr(setw,shm->Ldescr);
		wmove(setw,TELNO_Y,TELNO_X);
		waddstr(setw,shm->Ltelno);
	}

}	/* end of setup_display_name */

/*+-------------------------------------------------------------------------
	setup_display_tty()
000000000011111
012345678901234
/dev/ttyxxxxxx
--------------------------------------------------------------------------*/
void
setup_display_tty()
{
	clear_area(setw,TTY_Y,TTY_X,TTY_LEN);
	waddstr(setw,&shm->Lline[8]);
}	/* end of setup_display_tty */

/*+-------------------------------------------------------------------------
	setup_display_single_char()
--------------------------------------------------------------------------*/
void
setup_display_single_char()
{
	wmove(setw,DPX_Y,DPX_X);
	waddch(setw,(shm->Lfull_duplex) ? 'F' : 'E');
	wmove(setw,PAR_Y,PAR_X);
	waddch(setw,(shm->Lparity) ? to_upper(shm->Lparity) : 'N');
	wmove(setw,DB_Y,DB_X);
	waddch(setw,(shm->Lparity) ? '7' : '8');
	wmove(setw,XADDNL_Y,XADDNL_X);
	waddch(setw,(shm->Ladd_nl_outgoing) ? 'Y' : 'N');
	wmove(setw,RADDNL_Y,RADDNL_X);
	waddch(setw,(shm->Ladd_nl_incoming) ? 'Y' : 'N');

 }	/* end of setup_display_single_char */

/*+-------------------------------------------------------------------------
	setup_display_baud()
--------------------------------------------------------------------------*/
void
setup_display_baud()
{
char s8[8];
	clear_area(setw,BAUD_Y,BAUD_X,BAUD_LEN);
	sprintf(s8,"%u",shm->Lbaud);
	waddstr(setw,s8);

}	/* end of setup_display_baud */

/*+-------------------------------------------------------------------------
	setup_display_screen(write_lits)
--------------------------------------------------------------------------*/
void
setup_display_screen(write_lits)
int write_lits;
{
	if(write_lits)
	{
		wmove(setw,NAME_Y,NAME_LX);
		waddstr(setw,"Name/phone number to call:");
		wmove(setw,TTY_Y,TTY_LX);
		waddstr(setw,"tty: /dev/tty");
		wmove(setw,DPX_Y,DPX_LX);
		waddstr(setw,"duplex:");
		wmove(setw,BAUD_Y,BAUD_LX);
		waddstr(setw,"baud:");
		wmove(setw,PAR_Y,PAR_LX);
		waddstr(setw,"parity:");
		wmove(setw,DB_Y,DB_LX);
		waddstr(setw,"(data bits");
		wmove(setw,DB_Y,DB_LX2);
		waddch(setw,')');
		wmove(setw,XADDNL_Y,XADDNL_LX);
		waddstr(setw,"Add NL to transmitted CR:");
		wmove(setw,RADDNL_Y,RADDNL_LX);
		waddstr(setw,"Add NL to received CR:");
		wmove(setw,SETW_LINES - 2,1);
		wstandout(setw);
		waddstr(setw,		/* kludge -- must change if setw width does */
			"   TAB:next ^B:prev END:proceed ^D:phone dir  ESC:quit ecu    ");
		wstandend(setw);
	}
	setup_display_name();
	setup_display_tty();
	setup_display_single_char();
	setup_display_baud();
	wrefresh(setw);
}	/* end of setup_display_screen */

/*+-------------------------------------------------------------------------
	setup_open_status()
--------------------------------------------------------------------------*/
void
setup_open_status()
{
	wmove(setw,TTYOPN_LY,TTYOPN_LX);
	if(shm->Liofd >= 0)
		waddstr(setw,"(opened)");
	else
		waddstr(setw,"        ");
	wrefresh(setw);
}	/* end of setup_open_status */

/*+-------------------------------------------------------------------------
	setup_line_open()
--------------------------------------------------------------------------*/
setup_line_open()
{
register itmp;
char *lopen_err_text();

	if(itmp = lopen())
	{
		setw_err_msg(lopen_err_text(itmp));
		ring_bell();
	}
	setup_open_status();
	return(itmp);

}	/* end of setup_line_open */

/*+-------------------------------------------------------------------------
	setw_get_single(nondelim_list)
assumes cursor is already positioned
--------------------------------------------------------------------------*/
int
setw_get_single(nondelim_list)
register char *nondelim_list;
{
register uint itmp;
static char setw_nondelim_list[] =
{
	CR,NL,CTL_B,CTL_D,TAB,ESC,CTL_L,CTL_R,END
};

	itmp = winget_single(setw,nondelim_list,setw_nondelim_list);
	if( (itmp & 0xFF) == CR)
		itmp = NL | 0x1000;
	return(itmp);
}	/* end of setw_get_single */

/*+-------------------------------------------------------------------------
	setup_screen(argv_logical)
--------------------------------------------------------------------------*/
void
setup_screen(argv_logical)
char *argv_logical;
{
register itmp;
register input_state = 0;
char s64[64];
int done = 0;
uint baud;
uchar delim;	/* important to be unsigned to avoid sign extension */
WINDOW *window_create();
static char use_input_delim[] = {TAB,NL,END,CTL_D};

	windows_start();
	sprintf(s64,"ecu %s%s",numeric_revision,revision_modifier);
	setw = window_create(s64,-3,SETW_TLY,SETW_TLX,SETW_LINES,SETW_COLS);
	setup_display_screen(1);

REENTER_INPUT_LOOP:
	while(!done)
	{
		wrefresh(setw);
		switch(input_state)
		{
			case 0:
CASE_0:
				if(argv_logical)
				{
					itmp = 0;	/* 'ecu -' means dont dial */
					if(strcmp(argv_logical,"-"))	/* if not "-" */
					{
						strncpy(s64,argv_logical,NAME_LEN + 1);
						s64[NAME_LEN + 1] = 0;
						itmp = strlen(s64);
					}
					delim = END;
				}
				else
				{
					setw_bot_msg(
						"logical phone directory entry, phone number or empty");
 					itmp = wingets(setw,NAME_Y,NAME_X,s64,NAME_LEN + 1,&delim,
						(shm->Llogical[0] != 0));
					setw_err_msg("");
				}
				if(strchr(use_input_delim,delim) && strlen(s64))
				{
					strcpy(shm->Llogical,s64);
					if(shm->Llogical[0] && (lookup_logical_telno() == 0))
					{
						setw_err_msg(errmsg);
						setup_display_screen(0);
						ring_bell();
						argv_logical = (char *)0;
						goto CASE_0;
					}
					setup_display_screen(0);
					break;
				}
				setup_display_name();
				break;

			case 1:
				setw_bot_msg("comm line: i.e., 1a, 2a, 4a, 4b, 4c, 4d");
				setup_display_tty();
				strcpy(s64,&shm->Lline[8]);
 				itmp = wingets(setw,TTY_Y,TTY_X,s64,TTY_LEN + 1,&delim,1);
				setw_err_msg("");
				if(strchr(use_input_delim,delim) && strlen(s64))
					strcpy(&shm->Lline[8],s64);
				setup_display_tty();
				break;

			case 2:
				setw_bot_msg("duplex F:full H:half");
				wmove(setw,DPX_Y,DPX_X);
				wrefresh(setw);
				delim = NL;
				switch(itmp = setw_get_single("fh"))
				{
					case 0:
					case 1:
						shm->Lfull_duplex = itmp;
						break;
					default:
						delim = itmp & 0xFF;
						break;
				}
				break;

			case 3:		/* baud */
				setw_bot_msg(
				"rates: 110,300,600,1200,2400,4800,9600,19200,38400");
CASE_3:
				sprintf(s64,"%u",shm->Lbaud);
 				itmp = wingets(setw,BAUD_Y,BAUD_X,s64,BAUD_LEN + 1,&delim,1);
				if(strchr(use_input_delim,delim) && strlen(s64))
				{
					if(valid_baud_rate(baud = atoi(s64)) < 0)
					{
						setup_display_baud();
						ring_bell();
						goto CASE_3;
					}
					shm->Lbaud = baud;
				}
				setup_display_baud();
				break;

			case 4:
				setw_bot_msg("parity: N:none E:even O:odd");
				wmove(setw,PAR_Y,PAR_X);
				wrefresh(setw);
				delim = NL;
				switch(itmp = setw_get_single("neo"))
				{
					case 0:	shm->Lparity = 0;   break;
					case 1: shm->Lparity = 'e'; break;
					case 2: shm->Lparity = 'o'; break;
					default:
						delim = itmp & 0xFF;
						break;
				}
				wmove(setw,DB_Y,DB_X);
				waddch(setw,(shm->Lparity) ? '7' : '8');
				break;

			case 5:
				setw_bot_msg("");
				wmove(setw,XADDNL_Y,XADDNL_X);
				wrefresh(setw);
				delim = NL;
				switch(itmp = setw_get_single("ny"))
				{
					case 0:
					case 1: shm->Ladd_nl_outgoing = itmp; break;
					default: delim = itmp & 0xFF;
				}
				break;

			case 6:
				setw_bot_msg("");
				wmove(setw,RADDNL_Y,RADDNL_X);
				wrefresh(setw);
				delim = NL;
				switch(itmp = setw_get_single("ny"))
				{
					case 0:
					case 1: shm->Ladd_nl_incoming = itmp; break;
					default: delim = itmp & 0xFF; break;
				}
				break;
		}

		if(argv_logical)
			break;

		switch(delim)
		{
			case CTL_B:
				if(input_state)
					input_state--;
				else
					input_state = 6;
				break;

			case TAB:
			case NL:
				input_state++;
				input_state %= 7;
				break;

			case ESC:
				if(shm->Liofd >= 0)
					lclose();
				setw_bot_msg("");
				setup_open_status();
				hangup(0);
				break;

			case CTL_L:
			case CTL_R:
				clear_screen();
				touchwin(stdscr);
				wrefresh(stdscr);
				setup_display_screen(1);
				touchwin(setw);
				wrefresh(setw);
				break;

			case END:
			case CTL_D:
				done = 1;
				break;
		}
	}

	if(shm->Liofd < 0)
	{
		wmove(setw,TTY_Y,TTY_X);
		wrefresh(setw);
		if(setup_line_open())
		{
			done = 0;
			input_state = 1;
			argv_logical = (char *)0;
			goto REENTER_INPUT_LOOP;
		}
	}

	wmove(setw,SETW_LINES - 2,1);
	wstandout(setw);
	waddstr(setw,		/* kludge -- must change if setw width does */
		"------- Press HOME then 'help' for further assistance --------");
	wstandend(setw);
	setw_bot_msg("");
	windows_end(setw);
	curmove(LINES - 1,0);
	if(delim == CTL_D)
	{
		rcvr_pid = -2;
		pde_list_manager();
	}
	else if(shm->Llogical[0])
	{
#ifdef AUTO_DIAL_PROC
		if(find_procedure(shm->Llogical))
		{
		char *pargv[2];
			pargv[0] = shm->Llogical;
			pargv[1] = "!INITIAL";
			rcvr_pid = 0;
			do_proc(2,pargv);
			start_rcvr_process(1);
		}
		else
		{
			rcvr_pid = -2;
			hayes_dial();
		}
#else
	rcvr_pid = -2;
	hayes_dial();
#endif
	}
	else
		start_rcvr_process(1);

}	/* end of setup_screen */

/* vi: set tabstop=4 shiftwidth=4: */
