/* CHK=0x1558 */
/*+-------------------------------------------------------------------------
	logevent.c - log ecu event
	wht%n4hgf@gatech.edu
--------------------------------------------------------------------------*/
/*+:EDITS:*/
/*:05-07-1990-21:24-wht@n4hgf---- 2.80 --- */
/*:03-25-1990-14:11-wht@n4hgf------ x2.70 ------- */
/*:07-03-1989-22:57-wht------ x2.00 ----- */
/*:06-27-1989-15:32-wht-break out of ecuutil.c */

#include <stdio.h>
#include <sys/locking.h>
#include "stdio_lint.h"
#include "lint_args.h"

/*+-------------------------------------------------------------------------
	ecu_log_event(event_note)
--------------------------------------------------------------------------*/
void
ecu_log_event(event_note)
char *event_note;
{
char tstr256[256];
FILE *ecu_log_fp;
static char logname[128] = "";

	if(!logname[0])
	{
		get_home_dir(tstr256);
		strcat(tstr256,"/.ecu/log");
	}
	if((ecu_log_fp = fopen(tstr256,"a")) != NULL)
	{
		locking(fileno(ecu_log_fp),LK_LOCK,0L);
		get_tod(2,tstr256);
		tstr256[10] = '-';
		fputs(tstr256,ecu_log_fp);
		fprintf(ecu_log_fp,"-%05d-",getpid());
		fputs(event_note,ecu_log_fp);
		fputs("\n",ecu_log_fp);
		fflush(ecu_log_fp);
		locking(fileno(ecu_log_fp),LK_UNLCK,0L);
		fclose(ecu_log_fp);
	}
}	/* end of ecu_log_event */


/* vi: set tabstop=4 shiftwidth=4: */
/* end of logevent.c */
