/* CHK=0x6078 */
/*+-------------------------------------------------------------------------
	pcmdwhile.c - ecu procedure if commands
	wht%n4hgf@gatech.edu

    WHILEI $i0 rel-op $i1 cmd
    WHILES $s0 rel-op $s1 cmd

    where rel-op is "=", "==", "!=", "<>", ">", "<", ">=", "=<"

  Defined functions:
	cmd_whilei(param)
	cmd_whiles(param)

--------------------------------------------------------------------------*/
/*+:EDITS:*/
/*:05-07-1990-21:24-wht@n4hgf---- 2.80 --- */
/*:04-19-1990-03:08-wht@n4hgf-GCC run found unused vars -- rm them */
/*:03-25-1990-14:11-wht@n4hgf------ x2.70 ------- */
/*:11-06-1989-02:31-wht-add logical operators */
/*:07-03-1989-22:57-wht------ x2.00 ----- */
/*:06-24-1989-16:53-wht-flush edits --- ecu 1.95 */

#include <ctype.h>
#include "ecu.h"
#include "ecuerror.h"
#include "esd.h"
#include "var.h"
#include "proc.h"
#include "relop.h"

extern PCB *pcb_stack[];
extern int proc_level;

/*+-------------------------------------------------------------------------
    cmd_whilei(param)
--------------------------------------------------------------------------*/
int
cmd_whilei(param)
ESD *param;
{
register erc;
int truth;
PCB *pcb;
LCB *condition_lcb;
int condition_index = param->index;

	if(!proc_level)
		return(eNotExecutingProc);

	pcb = pcb_stack[proc_level - 1];
	condition_lcb = pcb->current;

REPEAT_WHILE:

	if(erc = get_truth_int(param,&truth))
		return(erc);

/* if end of command, execute frame */
	if(end_of_cmd(param))
	{
		if(erc = execute_frame(truth))
		{
			if(erc == eContinueCommand)
				goto CONTINUE;
			if(erc == eBreakCommand)
				erc = 0;
			return(erc);
		}
	}
	else if(truth)
	{
		if(erc = execute_esd(param))
			return(erc);
	}

/* repeat if indicated */
CONTINUE:
	if(truth)
	{
		pcb->current = condition_lcb;
		param->index = param->old_index = condition_index;
		goto REPEAT_WHILE;
	}

	return(0);
}   /* end of cmd_whilei */

/*+-------------------------------------------------------------------------
    cmd_whiles(param)
--------------------------------------------------------------------------*/
int
cmd_whiles(param)
ESD *param;
{
register erc;
int truth;
PCB *pcb;
LCB *condition_lcb;
int condition_index = param->index;

	if(!proc_level)
		return(eNotExecutingProc);

	pcb = pcb_stack[proc_level - 1];
	condition_lcb = pcb->current;

REPEAT_WHILE:

	if(erc = get_truth_str(param,&truth))
		return(erc);

/* if end of command, execute frame */
	if(end_of_cmd(param))
	{
		if(erc = execute_frame(truth))
		{
			if(erc == eContinueCommand)
				goto CONTINUE;
			if(erc == eBreakCommand)
				erc = 0;
			return(erc);
		}
	}
	else if(truth)
	{
		if(erc = execute_esd(param))
			return(erc);
	}

/* repeat if indicated */
CONTINUE:
	if(truth)
	{
		pcb->current = condition_lcb;
		param->index = param->old_index = condition_index;
		goto REPEAT_WHILE;
	}

	return(0);
}   /* end of cmd_whiles */

/* vi: set tabstop=4 shiftwidth=4: */
/* end of pcmdwhile.c */
