/* CHK=0x4B60 */
/*+-------------------------------------------------------------------------
	poutput.c - ecu procedure output routines
	wht%n4hgf@gatech.edu

  Defined functions:
	cmd_plog(param)
	pperror(str)
	pputc(ch)
	pputs(str)

--------------------------------------------------------------------------*/
/*+:EDITS:*/
/*:05-07-1990-21:24-wht@n4hgf---- 2.80 --- */
/*:04-19-1990-03:08-wht@n4hgf-GCC run found unused vars -- rm them */
/*:03-25-1990-14:11-wht@n4hgf------ x2.70 ------- */
/*:07-03-1989-22:57-wht------ x2.00 ----- */
/*:06-24-1989-16:53-wht-flush edits --- ecu 1.95 */

#include "ecu.h"
#include "ecukey.h"
#include "ecuerror.h"
#include "esd.h"

extern int proctrace;

FILE *plog_fp = (FILE *)0;
ESD *plog_name = (ESD *)0;

/*+-------------------------------------------------------------------------
	plogs(str)
--------------------------------------------------------------------------*/
void
plogs(str)
char *str;
{
	if(plog_fp)
		fputs(str,plog_fp);
}	/* end of plogs */

/*+-------------------------------------------------------------------------
	plogc(ch)
--------------------------------------------------------------------------*/
void
plogc(ch)
char ch;
{
	if(plog_fp)
		fputc(ch,plog_fp);
}	/* end of plogc */

/*+-------------------------------------------------------------------------
	pputc(ch) - put procedure output character to stderr and log
--------------------------------------------------------------------------*/
void
pputc(ch)
char ch;
{
	if(ch == NL)
		fputc(CR,se);
	fputc(ch,se);
	if(plog_fp && (ch != CR))
		fputc(ch,plog_fp);
}	/* end of pputc */

/*+-------------------------------------------------------------------------
	pputs(str) - put procedure output string to stderr and log
--------------------------------------------------------------------------*/
void
pputs(str)
register char *str;
{
	while(*str)
	{
		if(*str == NL)
			fputc(CR,se);
		fputc(*str,se);
		if(plog_fp && (*str != CR))
			fputc(*str,plog_fp);
		str++;
	}
}	/* end of pputs */

/*+-------------------------------------------------------------------------
	pflush()
--------------------------------------------------------------------------*/
void
pflush()
{
	if(plog_fp)
		fflush(plog_fp);
}	/* end of pflush */

/*+-------------------------------------------------------------------------
	pperror(str)
--------------------------------------------------------------------------*/
void
pperror(str)
char *str;
{
extern char *sys_errlist[];
extern int sys_nerr;
extern int errno;
int save_errno = errno;

	if(str && *str)
	{
		pputs(str);
		pputs(": ");
	}
	if(save_errno <= sys_nerr)
		pputs(sys_errlist[save_errno]);
	else
		pprintf("error %d",save_errno);
	pputs("\n");
}	/* end of pperror */

/*+-------------------------------------------------------------------------
	plog_control(fname)
 fname == 0, close
 fname == 1, plog_name already plugged
--------------------------------------------------------------------------*/
int
plog_control(fname)
char *fname;
{
	if(!fname)	/* close */
	{
		if(plog_fp)
			fclose(plog_fp);
		plog_fp = (FILE *)0;
		return(0);
	}

	if(plog_fp)
		plog_control((char *)0);

	if(fname != (char *)1)
	{
		strcpy(plog_name->pb,fname);
		plog_name->cb = strlen(fname);
	}

	if((plog_fp = fopen(plog_name->pb,"a")) == NULL)
	{
		pperror(plog_name->pb);
		return(eFATAL_ALREADY);
	}
	return(0);
}	/* end of plog_control */

/*+-------------------------------------------------------------------------
	cmd_plog(param)

plog $s0     log to file
plog off     stop logging
plog         show status
--------------------------------------------------------------------------*/
int
cmd_plog(param)
ESD *param;
{
int erc;
char off_str[8];

	if(!skip_cmd_break(param))	/* if arguments */
	{
		if(!get_alpha_zstr(param,off_str,sizeof(off_str)))
		{
			if(strcmp(off_str,"off"))
				return(eBadParameter);
			erc = plog_control((char *)0);
		}
		else
		{
			if(erc = gstr(param,plog_name))
				return(erc);
			erc = plog_control((char *)1);
		}
	}
	return(erc);

}	/* end of cmd_plog */

/*+-------------------------------------------------------------------------
	poutput_init()
--------------------------------------------------------------------------*/
void
poutput_init()
{
	if((plog_name = make_esd(256)) == (ESD *)0)
	{
		ff(se,"Out of memory\r\n");
		hangup(1);
	}
}	/* end of poutput_init */

/* vi: set tabstop=4 shiftwidth=4: */
/* end of poutput.c */
