/* CHK=0xCD25 */
/*+-------------------------------------------------------------------------
	sysdep.c -- system dependency aid
--------------------------------------------------------------------------*/
/*+:EDITS:*/
/*:05-07-1990-21:24-wht@n4hgf---- 2.80 --- */
/*:03-25-1990-14:12-wht@n4hgf------ x2.70 ------- */
/*:11-25-1989-16:13-wht-add M_UNIX */
/*:07-06-1989-15:06-wht-added i386 */
/*:02-27-1989-21:59-wht-add M_I286 and M_I386 */
/*:11-17-1988-15:17-wht-creation */

#include <stdio.h>

char	*defines[] =
{
#if defined(M_UNIX)
	"M_UNIX",
#undef M_XENIX		/* <---------------------- */
#endif
#if defined(M_XENIX)
	"M_XENIX",
#endif
#if defined(M_SYS5)
	"M_SYS5",
#endif
#if defined(M_I386)
	"M_I386",
#endif
#if defined(M_I286)
	"M_I286",
#endif
#if defined(M_I186)
	"M_I186",
#endif
#if defined(M_I8086)
	"M_I8086",
#endif
#if defined(M_I86)
	"M_I86",
#endif
#if defined(pyr)
	"pyr",
#endif
#if defined(i386)
	"i386",
#endif
#if defined(sun)
	"sun",
#endif
#if defined(sun2)
	"sun2,
#endif
#if defined(sun3)
	"sun3",
#endif
#if defined(sun4)
	"sun4",
#endif
#if defined(vax)
	"vax",
#endif
#if defined(pdp11)
	"pdp11",
#endif
#if defined(M_INTERNAT)
	"M_INTERNAT",
#endif
	(char *)0
};

/*+-------------------------------------------------------------------------
	pos_in_ztermed_list(test,list)
--------------------------------------------------------------------------*/
int
pos_in_ztermed_list(test,list)
char	*test;
char	**list;
{
	register int itmp = 0;

	while(*list)
	{
		if(!strcmp(*list++,test))
			return(itmp);
		itmp++;
	}
	return(-1);
}	/* end of pos_in_ztermed_list */

/*+-------------------------------------------------------------------------
	main(argc,argv,envp)
--------------------------------------------------------------------------*/
main(argc,argv,envp)
int argc;
char	**argv;
char	**envp;
{
register int iargv;
char **cpptr;

	for(iargv = 1; iargv < argc; iargv++)
	{
		if(*argv[iargv] == '=')
		{
			if(pos_in_ztermed_list(argv[iargv] + 1,defines) >= 0)
				break;
		}
	}
	if(iargv == argc)
	{
		fprintf(stderr,"\n\nsysdep: no system match\n\n");
		fprintf(stderr,"On this system, I recognize:\n");
		cpptr = defines;
		while(*cpptr)
			fprintf(stderr,"    %s\n",*cpptr++);
		fputs("\n",stderr);
		exit(1);
	}

	while(++iargv <argc)
	{
		if(*argv[iargv] == '=')
			break;
		fputs(argv[iargv],stdout);
		fputc(' ',stdout);
	}
	fputs("\n",stdout);
	exit(0);
}	/* end of main */

